<?php

namespace FiloBlu\Storelocator\Block\System\Config\Button;

use Magento\Framework\App\Config\ScopeConfigInterface;

class GmbLogin extends \Magento\Config\Block\System\Config\Form\Field {

    /**
     * Path to block template
     */
    const GMB_TEMPLATE = 'system/config/button/gmb_login.phtml';

    public $_googleApi;
    public $config = null;

    /**
     * @param \Magento\Backend\Block\Template\Context $context
     * @param array $data
     */
    public function __construct(\FiloBlu\Storelocator\Model\Google\Api $googleApi, \Magento\Backend\Block\Template\Context $context, array $data = []) {
        $this->_googleApi = $googleApi;
        $this->config = $context->getScopeConfig();
        parent::__construct($context, $data);
    }

    /**
     * Set template to itself
     *
     * @return $this
     */
    protected function _prepareLayout() {
        parent::_prepareLayout();
        if (!$this->getTemplate()) {
            $this->setTemplate(static::GMB_TEMPLATE);
        }
        return $this;
    }

    /**
     * Render button
     *
     * @param  \Magento\Framework\Data\Form\Element\AbstractElement $element
     * @return string
     */
    public function render(\Magento\Framework\Data\Form\Element\AbstractElement $element) {
        // Remove scope label
        $element->unsScope()->unsCanUseWebsiteValue()->unsCanUseDefaultValue();
        return parent::render($element);
    }

    /**
     * Get the button and scripts contents
     *
     * @param \Magento\Framework\Data\Form\Element\AbstractElement $element
     * @return string
     */
    protected function _getElementHtml(\Magento\Framework\Data\Form\Element\AbstractElement $element) {
        $originalData = $element->getOriginalData();
        $this->addData(
                [
//                'api_key_id' => $originalData['api_key_id'],
//                'api_domain_id' => $originalData['api_domain_id'],
//                'intern_url' => $this->getUrl($originalData['button_url']),
//                'load_config_url' => $this->getUrl($originalData['load_config_url']),
                    'html_id' => $element->getHtmlId(),
                ]
        );
        return $this->_toHtml();
    }

}
