<?php

namespace FiloBlu\Storelocator\Controller;

class Router implements \Magento\Framework\App\RouterInterface
{
    /**
     * @var \Magento\Framework\App\ActionFactory
     */
    protected $actionFactory;

    /**
     * Helper
     *
     * @var \FiloBlu\Storelocator\Helper\Data
     */
    protected $_helper;


    public function __construct(
        \Magento\Framework\App\ActionFactory $actionFactory,
        \FiloBlu\Storelocator\Helper\Data $helper
    )
    {
        $this->actionFactory = $actionFactory;
        $this->_helper = $helper;
    }

    /**
     * Validate and Match Cms Page and modify request
     *
     * @param \Magento\Framework\App\RequestInterface $request
     * @return bool
     */
    public function match(\Magento\Framework\App\RequestInterface $request)
    {
        $helper = $this->_helper;
        if ($helper->getConfig('filoblu_storelocator_section/general/enabled')) {
            $url_prefix = $helper->getConfig('filoblu_storelocator_section/general/url_prefix');
            $url_suffix = $helper->getConfig('filoblu_storelocator_section/general/url_suffix');
            if ($url_prefix == '') {
                return $this;
            }
            $path = trim($request->getPathInfo(), '/');

            if ($path == $url_prefix . $url_suffix) {
                $array = explode('/', $path);

                if (count($array) == 1) {
                    $request->setAlias(\Magento\Framework\UrlInterface::REWRITE_REQUEST_PATH_ALIAS, $path . $url_suffix);
                    $request->setPathInfo('/' . 'storelocator/index/index');

                    return $this->actionFactory->create('Magento\Framework\App\Action\Forward');
                }
            }
        }
    }
}
